#-*- coding: UTF-8 -*- 
# 关于设备的获取的功能，主要包括获取设备列表，获取设备具体状态等
from flask import Blueprint
from flask import request,jsonify,jsonify
from models import *
from hashmd5 import *

import traceback
import sys
import VTime
device_list=Blueprint('device_list',__name__)




#  添加设备
@device_list.route('/adddevicelist',methods=['POST'])
def adddevicdlist():
    try: 
        user_id = request.json['token']
        deviceid =request.json['deviceid']
        passwd = request.json['passwd']
        try:
            device = DeviceList.query.filter_by(id=deviceid).filter_by(password=passwd).first()
            if device is None:
                state = 'fail'
                reason = '设备不存在'
                devicestate =''

            else:
                device.user_id =user_id
                device.add()
                state = 'successful'
                reason =' '

        except Exception, e:
            print e
            state = 'fail'
            reason = '服务器异常'
    except Exception, e:
        print e
        state = 'fail'
        reason = '参数不正确'
    return jsonify({'state':state,'reason':reason})


#返回每个设备最新的状态

@device_list.route('/getdevicedetails',methods=['POST'])
def getdevicedetails():

    try：
        userid = request.json['token']      
        deviceid =request.json['deviceid']
    except Exception, e:
        print e
        state = 'fail'
        reason ='参数不正确'
        return return jsonify({'state':state,'reason':reason})
    try:
        device = DeviceList.query.filter_by(id=deviceid).filter_by(user_id=userid).first()
        type = device.type
        name = device.name
        devicestate = device.state
        amount = device.amount

        data1 = TimingTask.query.filter_by(userid=userid).filter_by(deviceid=deviceid).filter(or_(TimingTask.setflag=='0',TimingTask.setflag=='1',TimingTask.setflag=='2')).order_by(TimingTask.timestamp.desc()).first()
        data2 = RealTimeTask.query.filter_by(userid=userid).filter_by(deviceid=deviceid).order_by(RealTimeTask.timestamp.desc()).first()

        if data1 is None and data2 is None:

            state = 'successful'
            reason = ''
            tasktype  = '-1'
            return jsonify({'state':state,'reason':reason,'tasktype':tasktype,'type':type,'name':name,'devicestate':devicestate,'amount':amount})
        if data2 is None:

            tasktype = '1'
            starttime = data1.starttime
            days = data1.days
            state = 'successful'
            reason = ''
            return jsonify({'state':state,'reason':reason,'tasktype':tasktype,'type':type,'name':name,'devicestate':devicestate,'starttime':starttime,'days':days,'amount':amount })
        if data1 is None:

            tasktype = '0'
            state = 'successful'
            reason = ''
            return jsonify({'state':state,'reason':reason,'tasktype':tasktype,'type':type,'name':name,'devicestate':devicestate,'amount':amount})
        if data1 is not None and data2 is not None:

            if data1.timestamp > data2.timestamp:
                tasktype = '1'
                starttime = data1.starttime
                days = data1.days
                state = 'successful'
                reason = ''
                return jsonify({'state':state,'reason':reason,'tasktype':tasktype,'type':type,'name':name,'devicestate':devicestate,'starttime':starttime,'days':days,'amount':amount })
            else:
                tasktype = '0'
                state = 'successful'
                reason = ''
                return jsonify({'state':state,'reason':reason,'tasktype':tasktype,'type':type,'name':name,'devicestate':devicestate,'amount':amount})

    except Exception:
        print e
        state = 'fail'
        reason = '服务器异常'

    return jsonify({'state':state,'reason':reason})

# 6. 获取设备的列表
@device_list.route('/getdevicelist',methods=['POST'])
def getdevicelist():
            
    result = []
    try:
        token = request.json['token']
        devicelist = DeviceList.query.filter_by(user_id=token).all()
        if devicelist is None:
            state = 'fail'
            reason = '该设备不存在'
        else:    
            for device in devicelist:
                output={'deviceid':device.id,'type':device.type,'name':device.name}
                result.append(output)
            state = 'successful'
            reason = ''
      
    except Exception, e:
        print e 
        state = 'fail'
        reason = '服务器异常'
       
    return jsonify({'state':state,'reason':reason,'devicelist':result})

# 7. 获取设备的某一状态
@device_list.route('/getdevicestate',methods=['POST'])
def getdevicestate():
  
    
      
    try:

        token = request.json['token']
   
        deviceid = request.json['deviceid']
        
        device = DeviceList.query.filter_by(user_id=token).filter_by(id=deviceid).first()

        if device is None:
            state = 'fail'
            reason = '该设备未使用'
            devicestate=''
            amount = ''
        else:
            devicestate = device.state

            amount = device.amount
            state = 'successful'
            reason = ''
     
    except Exception, e:
        print e 
        state = 'fail'
        reason = '服务器异常'            
        devicestate = ''
        amount = ''
      
    return jsonify({'state':state,'reason':reason,'devicestate':devicestate,'amount':amount})
    

# 8. 获取某一设备历史数据
@device_list.route('/getdevicedata',methods=['POST'])
def getdevicedata():
          
    result=[]
    try:
        token = request.json['token']
        deviceid = request.json['deviceid']
        historydata = HistoryData.query.filter_by(device_id=deviceid).all()
        if historydata is None:
            state = 'fail'
            reason = '无历史数据'
        else:
            for data in historydata:
                output={'starttime':data.starttime,'amount':data.amount}
                result.append(output)
            state = 'successful'
            reason = ''
     
    except Exception, e:
        print e 
        state = 'fail'
        reason = '服务器异常'

    return jsonify({'state':state,'reason':reason,'historydata':result})        

# 9.获取某设备详细信息
@device_list.route('/getdevevicedetails',methods=['POST'])
def getdevicedetail():
      
    try:
        token = request.json['token']
        deviceid = request.json['deviceid']
        device = DeviceList.query.filter_by(user_id=token).filter_by(id=deviceid).first()
        if device is None:
            state = 'fail'
            reason = '该设备未使用'
            devicestate = ''
            devicename = ''
            devicecode = ''
        else:
            devicestate = device.state
            devicename =device.name
            devicecode = device.id
            state = 'successful'
            reason = ''
   
    except Exception, e:
        print e 
        state = 'fail'
        reason = '服务器异常'            
        devicestate = ''
       
    return jsonify({'state':state,'reason':reason,'devicestate':devicestate,'devicename':devicename,'devicecode':deviceid})    

#  开启实时设备

@device_list.route('/setdevicerealtimetask',methods=['POST'])
def openrealtimedevice():
        
    try:
        userid = int(request.json['token'])
        starttime = request.json['starttime']
        deviceid = int(request.json['deviceid'])
        amount = int(request.json['amount'])
        devicetype = request.json['devicetype']
        sceneid = int('-1')
        setflag = int('0')

        device = RealTimeTask.query.filter_by(userid=userid).filter_by(deviceid=deviceid).first()
        if device is None:

            d=RealTimeTask(deviceid=deviceid,starttime=starttime,amount=amount,devicetype=devicetype,userid=userid,sceneid=sceneid,timestamp=datetime.now())
            d.add()
            state = 'successful'
            reason = 'add'
        else:
            device.amount = amount
            device.setflag = setflag
            device.sceneid = sceneid
            device.starttime = starttime
            device.timestamp =datetime.now()
            device.add()
            state = 'successful'
            reason = 'update'

    except Exception, e:
        print e
        state = 'fail'
        reason = '服务器异常'

    return jsonify({'state':state,'reason':reason})

# 关闭实时设备

@device_list.route('/canceldevicerealtimetask',methods=['POST'])
def closerealtimedevice():
    
    try:
        userid = int(request.json['token'])
        deviceid = int(request.json['deviceid'])
        setflag = int('3') 
        device = RealTimeTask.query.filter_by(userid=userid).filter_by(deviceid=deviceid).first()
        if device is None:
            state = 'fail'
            reason = '设备未开启'
        else:
            device.setflag=setflag
            device.add()
            state = 'successful'
            reason = ''

    except Exception, e:
        print e
        state = 'fail'
        reaon = '服务器异常'

    return jsonify({'state':state,'reason':reason})

# 开启定时设备
@device_list.route('/setdevicetimingtask',methods=['POST'])
def opentimingdevice():
    
    try:
        userid = int(request.json['token'])
        deviceid = int(request.json['deviceid'])
        starttime = request.json['starttime']
        days = request.json['days']
        amount= int(request.json['amount'])
        devicetype = request.json['devicetype']
        sceneid = int('-1')
        setflag = int('0')
        device = TimingTask.query.filter_by(userid=userid).filter_by(deviceid=deviceid).first()
        if device is None:
            d=TimingTask(deviceid=deviceid,amount=amount,devicetype=devicetype,userid=userid,sceneid=sceneid,starttime=starttime,days=days,timestamp=datetime.now())
            d.add()
            state = 'successful'
            reason = 'add'
        else:
            device.amount = amount
            device.starttime = starttime
            device.days = days
            device.amount = amount
            device.setflag = setflag
            device.sceneid = sceneid
            device.timestamp =datetime.now() 
            device.add()
            state = 'successful'
            reason = 'update'

    except Exception, e:
        print e
        state = 'fail'
        reason = '服务器异常'
      
    return jsonify({'state':state,'reason':reason})
    
    #关闭定时设备
@device_list.route('/canceldevicetimingtask',methods=['POST'])    
def closetimingdevice():
    
    try:
        userid = int(request.json['token'])
        deviceid = int(request.json['deviceid'])
        setflag = int('3') 
        device = TimingTask.query.filter_by(userid=userid).filter_by(deviceid=deviceid).first()
        if device is None:
            state = 'fail'
            reason = '设备未开启'
        else:
            device.setflag=setflag
            device.add()
            state = 'successful'
            reason = ''

    except Exception, e:
        print e
        state = 'fail'
        reason = '服务器异常'

    return jsonify({'state':state,'reason':reason})
            
    
    
    
'''
#设备更新进数据库
@device_list.route('/devicelist/add',methods=['POST'])
def add():
    try:
        id=request.values.get('id','default')
        user_id='0'
        password='admin'
        type=request.values.get('type','default')
        name = id
        
        d=DeviceList.query.filter_by(id=str(id)).first()
        
        if d is None:
            d=DeviceList(id=id,password=password,type=type,name=name,user_id=user_id)
            d.add()
            state='successful'
            reason=''
        else:
            state = 'fail'
            reason = '设备已经注册'
            
    except Exception, e:
        print e
        state ='fail'
        reason='服务器异常'
    return jsonify({'state':state,'reason':reason})          

#设备更新名称
@device_list.route('/devicelist/changename',methods=['POST'])
def changename():
    try:
        id=request.values.get('id','default')
        name=request.values.get('name','default')
        d=DeviceList.query.filter_by(id=str(id)).first()
        
        if d is None:
            state = 'fail'
            reason = '该设备未启用'
        else:
            d.name=name
            try:
                db.session.add(d)
                db.session.commit()    
                state='successful'
                reason=''
            except Exception, e:
                print e
                db.session.rollback()
                state = 'fail'
                reason = '数据库事务提交失败'
                
        
    except Exception, e:
        print e
        state = 'fail'
        reason = '服务器异常'
    return jsonify({'state':state,'reason':reason})        



#设备更新所属用户
@device_list.route('/devicelist/updateuserid',methods=['POST'])
def updateid():
    try:
        id=request.values.get('id','default')
        user_id=request.values.get('user_id','default')
        d=DeviceList.query.filter_by(id=str(id)).first()
        
        if d is None:
            state = 'fail'
            reason = '该设备未启用'
        else:
            d.user_id=user_id
            try:
                db.session.add(d)
                db.session.commit()    
                state='successful'
                reason=''
            except Exception, e:
                print e
                db.session.rollback()
                state = 'fail'
                reason = '数据库事务提交失败'
                
        
    except Exception, e:
        print e
        state = 'fail'
        reason = '服务器异常'
    return jsonify({'state':state,'reason':reason})     

'''



